/*
 * CurrentControl.h
 *
 *  Created on: Jan 21, 2015
 *      Author: Campbell
 */

#ifndef CURRENTCONTROL_H_
#define CURRENTCONTROL_H_

#include "CurrentCommand.h"

typedef struct {
  // Gains.
  float Kp, Ki, Kc,Ka;
  // i-term memory.
  float iTerm;
  // Sampling time.
  float Ts;
} ComplexPI;

void CurrentRegulator(float Id_cmd, float Iq_cmd, float Ia, float Ib, float Ic, float Omega_m, float theta_r ,float Vdc, float *Vds_lim, float *Vqs_lim);

float ComplexCurCtrD(float DeltaId, float DeltaIq, float DeltaVd,float DeltaVq,float Omega_e,float Ts, ComplexPI* controller1, ComplexPI* controller2);

float ComplexCurCtrQ(float DeltaId, float DeltaIq, float DeltaVd,float DeltaVq,float Omega_e,float Ts,  ComplexPI* controller1, ComplexPI* controller2);

void ComplexCurCtrlinit(float pGain, float iGain, float cGain,  float aGain, float Ts, ComplexPI* controller);

float UpperLimit(float in, float max);

#endif /* CURRENTCONTROL_H_ */
