/*
 * OverModulation.h
 *
 *  Created on: Dec 22, 2014
 *      Author: mohajerani
 */

#ifndef OVERMODULATION_H_
#define OVERMODULATION_H_

#include "Utility.h"

/* ---------------------------------------------------------------------------------
 * Overmodulation constants
 */
#define M1        0.906908296
#define M2        0.951426151
#define M_LENGTH 	100

#define M1_STEP       0.000449675
#define M1_STEP_INV   2223.82832045366
#define M2_STEP       0.000490610
#define M2_STEP_INV   2038.27887731599
/* ---------------------------------------------------------------------------------
 * Overmoduilation vectors
 */
extern float M_IDX_MODE_I[];		    // Mode I modulation index
extern float M_ADJ_MODE_I[];		    // Mode I adjusted modulation index
extern float M_IDX_MODE_II[];		    // Mode II modulation index
extern float ALPHA_HOLD_MODE_II[];	// Mode II hold angle

/* ---------------------------------------------------------------------------------
 * Main overmodulation function.
 */
void overMod(float voltAlpha, float voltBeta, float* voltAlphaAdjust, float* voltBetaAdjust);

/* ---------------------------------------------------------------------------------
 * Mode I overmodulation, Holtz method.
 */
void overModModeI(float modCmd, float thetaSector, float* voltAlpha, float* voltBeta);

/* ---------------------------------------------------------------------------------
 * Mode II overmodulation, Holtz method.
 */
void overModModeII(float modCmd, float thetaSector, float* voltAlpha, float* voltBeta);

#endif /* OVERMODULATION_H_ */
