/*
 * pwm.h
 *
 *  Created on: Dec 22, 2014
 *      Author: mohajerani
 */

#ifndef PWM_H_
#define PWM_H_

#include "OverModulation.h"

/* ---------------------------------------------------------------------------------
 * PWM methods
 */
typedef enum {
	SVPWM = 1,
	GDPWM = 2,
	DPWMMIN = 3,
	DPWMMAX = 4
} PWMMethod;

/* ---------------------------------------------------------------------------------
 * Calculates ABC duty cycles from alpha-betta voltage commands.
 * Voltage commands are normalized to 2/pi*Vdc before being passed to this function.
 */
void voltageToDuty(float voltAlpha, float voltBeta, PWMMethod method, float thetaPF, float* dutyA, float* dutyB, float* dutyC);

/* ---------------------------------------------------------------------------------
 * Calculates the percentage of V0 and V7 based on PWM method and power factor.
 */
void zeroPartition(int method, float thetaSector, float thetaPF, float* zeta0, float* zeta7);

/* ---------------------------------------------------------------------------------
 * Calculates ABC duty-cycles from sector duty cycles and zero-vector partitions.
 */
void dutyCalc(int sectorNum, float dutyR, float dutyRp1, float duty07, float zeta0, float zeta7, float* dutyA, float* dutyB, float* dutyC);

#endif /* PWM_H_ */
