/** @file AppTask0.c
*   @brief Application Entry Point for Task 0
*   @date 14.Jan.2015
*   @version 00.00.00
*
*/

/* Include Files */
#include "HAL_API.h"
#include "PWM.h"
#include "MathLib.h"
#include "CurrentControlV3.h"

float  GeAT0_ThetaRads = 0;
extern float Id_cmd, Iq_cmd;
extern float Vdc;
extern float Omega_m;

void AppTask0Init( void )
{

}

void AppTask0( void )
{
	float freq_hz = 50;
	float ts = 0.00005;
	float dtheta = ts * TWO_PI * freq_hz;

	float m = 0.91;

	float thetapf = -PI_SIXTH;
	PWMMethod method = GDPWM;

	float da, db, dc;
	float va, vb; // normalized values

	float vds_lim = 0;
	float vqs_lim = 0;
	float ia, ib, ic, theta_r;

	//Ia = 0;
	//Ib = 0;
	//Ic = 0;
	//theta_r = 0;

	CurrentRegulator(Id_cmd, Iq_cmd, ia, ib, ic, Omega_m, theta_r, Vdc, &vds_lim, &vqs_lim);

	if(GeAT0_ThetaRads >= 6.5)
		GeAT0_ThetaRads = 0;

	va = m  * cosTbl(GeAT0_ThetaRads);
	vb = m  * sinTbl(GeAT0_ThetaRads);
	voltageToDuty(va, vb, method, thetapf, &da, &db, &dc);
	setpwmApercent(da);
	setpwmApercent(db);
	setpwmApercent(dc);
	GeAT0_ThetaRads += dtheta;

}
