/** @file api.h
*   @brief api Driver Definition File
*   @date 9.Jan.2015
*   @version 00.00.00
*   
*/

#ifndef __API_H__
#define __API_H__

#include "HL_hal_stdtypes.h"

#ifdef __cplusplus
extern "C" {
#endif

extern void setflag(int i);
extern void clrflag(int i);

extern float pwmApercent;
extern float pwmBpercent;
extern float pwmCpercent;

void SetPWM( float A, float B, float C );
inline float getpwmApercent( void ) { return( pwmApercent ); }
inline float getpwmBpercent( void ) { return( pwmBpercent ); }
inline float getpwmCpercent( void ) { return( pwmCpercent ); }

inline void  setpwmApercent( float A ) { pwmApercent = A; }
inline void  setpwmBpercent( float B ) { pwmBpercent = B; }
inline void  setpwmCpercent( float C ) { pwmCpercent = C; }

extern void PwmPatternTest( void );
extern unsigned int get_task1_fake_processing( void );
extern unsigned int get_task2_fake_processing( void );
extern void set_task1_fake_processing( unsigned int data );
extern void set_task2_fake_processing( unsigned int data );

extern uint32 getTask0Count( void );
extern uint32 getTask1Count( void );
extern uint32 getTask2Count( void );

extern void AppTask0( void );
extern void AppTask1( void );
extern void AppTask2( void );

extern void AppTask0Init( void );
extern void AppTask1Init( void );
extern void AppTask2Init( void );


/**@}*/
#ifdef __cplusplus
}
#endif /*extern "C" */

#endif
