/** @file HL_sys_main.h
*   @brief main Definition File
*   @date 1.Jan.2015
*   @version 00.00.00
*   
*/


#ifndef __MAIN_H__
#define __MAIN_H__

#include "HL_gio.h"
#include "HL_etpwm.h"
#include "HL_adc.h"
#include "HL_het.h"

#include "HL_can.h"
#include "HL_esm.h"
#include "HL_sys_core.h"

#ifdef __cplusplus
extern "C" {
#endif

/* USER CODE BEGIN (0) */
//#define  FAUX_APP   ((bool)(1))

#ifdef FAUX_APP
void faux_app_task0(void);
void faux_app_task1(void);
void faux_app_task2(void);
#endif

/* USER CODE END */

/* scheduler related variables */
#define T0_RATE ((float) (50.0e-6))
#define T0_FREQ ((float) (1/T0_RATE))

// for now, T1 rate must be even integer multiple of T0 rate
#define T1_RATE ((float) (1.0e-3))
#define T1_FREQ ((float) (1/T1_RATE))

// for now, T2 rate must be even integer multiple of T1 rate
#define T2_RATE ((float) (10.0e-3))
#define T2_FREQ ((float) (1/T1_RATE))

//#define TASK_1_RATE    ((unsigned int) (T1_RATE/T0_RATE))
//#define TASK_2_RATE    ((unsigned int) (T2_RATE/T1_RATE))
#define TASK_1_RATE    ((unsigned int) 20)
#define TASK_2_RATE    ((unsigned int) 10)
#define MAX_TASK0_COUNT 10000

#define BLINK_RATE ((float) (250.0e-3))
#define BLINK_RATE_IN_T2_CNTS ((unsigned int) (BLINK_RATE/T2_RATE))

#define TOGGLE_LED (gioSetPort(hetPORT1, gioGetPort(hetPORT1) ^ (1 << 25) ))

boolean Task1Active;
boolean Task2Active;
boolean Task1Pending;
boolean Task2Pending;

uint32 IdleCount;
volatile uint32 Task0Count;
volatile uint32 Task1Count;
volatile uint32 Task2Count;

uint32 getTask0Count( void ) { return Task0Count; }
uint32 getTask1Count( void ) { return Task1Count;  }
uint32 getTask2Count( void ) { return Task2Count;  }

void Task1( void );
void Task2( void );

int temp = 0;
volatile int timer_00;
volatile int timer_01;
volatile int timer_02;
int tFlagON, tFlagOFF;

#define InitTestPointOutputs (gioSetDirection(hetPORT1, 0xFFFFFFFF))
#define SET_FLG_00	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 <<  3) )
#define CLR_FLG_00	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 <<  3) )
#define SET_FLG_01	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 24) )
#define CLR_FLG_01	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 24) )
#define SET_FLG_02	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 15) )
#define CLR_FLG_02	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 15) )
#define SET_FLG_03	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 21) )
#define CLR_FLG_03	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 21) )
#define SET_FLG_04	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 <<  1) )
#define CLR_FLG_04	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 <<  1) )

/* LEDs on eval board:           Mapped To:
 *
 *      17     31     00             06     07      00
 *
 *      27            05             05             01
 *
 *      29     18     25             04     03      02
 *
 *   can con1                     can con1
 */
#define SET_LED0	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 0) )
#define CLR_LED0	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 0) )
#define TGL_LED0	gioToggleBit(hetPORT1, 0 )
#define SET_LED1	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 05) )
#define CLR_LED1	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 05) )
#define TGL_LED1	gioToggleBit(hetPORT1, 5 )
#define SET_LED2	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 25) )
#define CLR_LED2	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 25) )
#define TGL_LED2	gioToggleBit(hetPORT1, 25 )
#define SET_LED3	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 18) )
#define CLR_LED3	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 18) )
#define TGL_LED3	gioToggleBit(hetPORT1, 18 )
#define SET_LED4	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 29) )
#define CLR_LED4	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 29) )
#define TGL_LED4	gioToggleBit(hetPORT1, 29 )
#define SET_LED5	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 27) )
#define CLR_LED5	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 27) )
#define TGL_LED5	gioToggleBit(hetPORT1, 27 )
#define SET_LED6	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 17) )
#define CLR_LED6	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 17) )
#define TGL_LED6	gioToggleBit(hetPORT1, 17 )
#define SET_LED7	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 << 31) )
#define CLR_LED7	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 << 31) )
#define TGL_LED7	gioToggleBit(hetPORT1, 31 )

void setflag( int i )
{
	/* no error checking! be careful! */
	gioSetPort(hetPORT1, gioGetPort(hetPORT1) |  (1 <<  i) );
}

void clrflag( int i )
{
	/* no error checking! be careful! */
	gioSetPort(hetPORT1, gioGetPort(hetPORT1) & ~(1 <<  i) );
}

unsigned int task1_fake_processing = 0;
unsigned int task2_fake_processing = 5;

unsigned int get_task1_fake_processing( void ) { return task1_fake_processing; }
unsigned int get_task2_fake_processing( void ) { return task2_fake_processing; }
void set_task1_fake_processing( unsigned int data ) { task1_fake_processing = data; }
void set_task2_fake_processing( unsigned int data ) { task2_fake_processing = data; }

/**@}*/
#ifdef __cplusplus
}
#endif /*extern "C" */

#endif
