/** @file Diag.c
*   @brief CAN Diagnostics file
*   @date 9.Jan.2015
*   @version 00.00.00
*
*/

#include "HL_system.h"

/* Include Files */
//#include "HAL_API.h"
#include "Diag.h"


 boolean CanDiagnostic( tCANdiag *pCanDiagRx, tCANdiag *pCanDiagTx );
 extern boolean jumpLoad;

 boolean CanDiagnostic( tCANdiag *pCanDiagRx, tCANdiag *pCanDiagTx )
 {
     
     switch( pCanDiagRx->c.Mode ) {

     case PeekCmd:
           pCanDiagTx->c.Address = pCanDiagRx->c.Address;
           pCanDiagTx->c.Data = *(unsigned *) pCanDiagRx->c.Address;
           pCanDiagTx->c.Mode = PeekRsp;
           break;

     case PokeFCmd:
          *(uint32 *) pCanDiagRx->c.Address = pCanDiagRx->c.Data;
          pCanDiagTx->c.Address = pCanDiagRx->c.Address;
          pCanDiagTx->c.Data = pCanDiagRx->c.Data;
          pCanDiagTx->c.Mode = PokeFRsp;
          break;

     case Poke32Cmd:
          *(uint32 *) pCanDiagRx->c.Address = pCanDiagRx->c.Data;
          pCanDiagTx->c.Address = pCanDiagRx->c.Address;
          pCanDiagTx->c.Data = pCanDiagRx->c.Data;
          pCanDiagTx->c.Mode = Poke32Rsp;
          break;

     case Poke16Cmd:
          *(uint16 *) pCanDiagRx->c.Address = (uint16) pCanDiagRx->c.Data;
          pCanDiagTx->c.Address = pCanDiagRx->c.Address;
          pCanDiagTx->c.Data = pCanDiagRx->c.Data;
          pCanDiagTx->c.Mode = Poke16Rsp;
          break;

     case Poke08Cmd:
          *(uint8 *) pCanDiagRx->c.Address = (uint8) pCanDiagRx->c.Data;
          pCanDiagTx->c.Address = pCanDiagRx->c.Address;
          pCanDiagTx->c.Data = pCanDiagRx->c.Data;
          pCanDiagTx->c.Mode = Poke08Rsp;
          break;

     case JumpLoadCmd:
          jumpLoad = true;
	      pCanDiagTx->u.Data0 = 0x1234567;	// dummy values
	      pCanDiagTx->u.Data1 = 0xabcdef01; // dummy values
          pCanDiagTx->c.Mode = JumpLoadRsp;
          break;

     case ExistCmd:
	      pCanDiagTx->u.Data0 = 0x1234567;	// dummy values
	      pCanDiagTx->u.Data1 = 0xabcdef01; // dummy values
          pCanDiagTx->c.Mode = ExistRsp;
          break;

     default:
          pCanDiagTx->c.Mode = ErrorRsp;
          break;

    }

     return( false );

 }
