/*----------------------------------------------------------------------------*/
/* sys_link.cmd                                                               */
/*                                                                            */
/* (c) Texas Instruments 2009-2013, All rights reserved.                      */
/*                                                                            */
/*----------------------------------------------------------------------------*/


/*----------------------------------------------------------------------------*/
/* Linker Settings                                                            */

--retain="*(.intvecs)"


/*----------------------------------------------------------------------------*/
/* Memory Map                                                                 */

MEMORY
{

    /* VECTORS      (X)  : origin=0x00000000 length=0x00000020 */
    BOOT_FLASH   (RX) : origin=0x00000020 length=0x0000BFE0 fill =0xffffffff
    BOOT_RECORD  (RW) : origin=0x0000C000 length=0x00004000 fill =0xffffffff
    APPA_VECTORS (X)  : origin=0x00010000 length=0x00000020 fill =0xffffffff
    APPA_FLASH   	(RX) : origin=0x00010020 length=0x000EFFE0 fill =0xffffffff
    APPA_FlashPOM	(RX) : origin=0x00100000 length=0x00010000 fill =0xffffffff
    APPA_FlashRES  	(RX) : origin=0x00110000 length=0x000F0000 fill =0xffffffff
    APPB_VECTORS 	(X)  : origin=0x00200000 length=0x00000020 fill =0xffffffff
    APPB_FLASH   	(RX) : origin=0x00200020 length=0x000EFFE0 fill =0xffffffff
    APPB_FlashPOM	(RX) : origin=0x00300000 length=0x00010000 fill =0xffffffff
    APPB_FlashRES  	(RX) : origin=0x00310000 length=0x000F0000 fill =0xffffffff
    VECTORS       (X) : origin=0x00000000 length=0x00000020    fill =0xffffffff


/* USER CODE BEGIN (3) */
    vx1100struct 	(RW) : origin=0x08000000 length=0x00100
	STACKS       	(RW) : origin=0x08000100 length=0x03000
    HAL_RamData 	(RW) : origin=0x08003100 length=0x00700
    APP_RamData		(RW) : origin=0x08003800 length=0x10000
	GP_RAM	    	(RW) : origin=0x08013800 length=0x10000
    APP_RamPOM     	(RW) : origin=0x08023800 length=0x10000
    DIAG_RAM     	(RW) : origin=0x0806B000 length=0x14F00
    RAM_VECTORS  	(X)  : origin=0x0807FF00 length=0x00100
    EEPROM_EMUL  	(RW) : origin=0xF0200000 length=0x20000
/* USER CODE END */
}

/*----------------------------------------------------------------------------*/
/* Section Configuration                                                      */

SECTIONS
{
    .intvecs         : {} > VECTORS /* APPA_VECTORS */
    .text   align(8) : {} > APPA_FLASH
    .const  align(8) : {} > APPA_FLASH
    .cinit  align(8) : {} > APPA_FLASH
    .pinit  align(8) : {} > APPA_FLASH
    .APP_FlashPOM    : {} > APPA_FlashPOM

    .bss             : {} > GP_RAM
    .data            : {} > GP_RAM
    .sysmem          : {} > GP_RAM
    .vx1100struct    : {} > vx1100struct
    .HAL_RamData     : {} > HAL_RamData
    .APP_RamData     : {} > APP_RamData

    .APP_EepromData  : {} > EEPROM_EMUL
}


