/*----------------------------------------------------------------------------
| TMS570 register defines
|-----------------------------------------------------------------------------
| Copyright (c) 2009 by Vector Informatik GmbH.  All rights reserved.
|---------------------------------------------------------------------------*/

#ifndef __TMS570_H__
#define __TMS570_H__



//
// RTP
//

#define TMS570_RTP_BASE_ADDR       (0xfffffa00UL)

#define TMS570_RTP_GLBCTRL_ADDR    ((TMS570_RTP_BASE_ADDR) + 0x00)
#define TMS570_RTP_TRENA_ADDR      ((TMS570_RTP_BASE_ADDR) + 0x04)
#define TMS570_RTP_GSR_ADDR        ((TMS570_RTP_BASE_ADDR) + 0x08)
#define TMS570_RTP_RAM1REG1_ADDR   ((TMS570_RTP_BASE_ADDR) + 0x0c)
#define TMS570_RTP_RAM1REG2_ADDR   ((TMS570_RTP_BASE_ADDR) + 0x10)
#define TMS570_RTP_RAM2REG1_ADDR   ((TMS570_RTP_BASE_ADDR) + 0x14)
#define TMS570_RTP_RAM2REG2_ADDR   ((TMS570_RTP_BASE_ADDR) + 0x18)
#define TMS570_RTP_RAM3REG1_ADDR   ((TMS570_RTP_BASE_ADDR) + 0x1c)
#define TMS570_RTP_RAM3REG2_ADDR   ((TMS570_RTP_BASE_ADDR) + 0x20)
#define TMS570_RTP_PERREG1_ADDR    ((TMS570_RTP_BASE_ADDR) + 0x24)
#define TMS570_RTP_PERREG2_ADDR    ((TMS570_RTP_BASE_ADDR) + 0x28)
#define TMS570_RTP_DDMW_ADDR       ((TMS570_RTP_BASE_ADDR) + 0x2c)
#define TMS570_RTP_PHANTOM_ADDR    ((TMS570_RTP_BASE_ADDR) + 0x30)
#define TMS570_RTP_PC0_ADDR        ((TMS570_RTP_BASE_ADDR) + 0x34)

#define TMS570_RTP_GLBCTRL         (*((volatile unsigned int*)TMS570_RTP_GLBCTRL_ADDR))
#define TMS570_RTP_TRENA           (*((volatile unsigned int*)TMS570_RTP_TRENA_ADDR))
#define TMS570_RTP_GSR             (*((volatile unsigned int*)TMS570_RTP_GSR_ADDR))
#define TMS570_RTP_RAM1REG1        (*((volatile unsigned int*)TMS570_RTP_RAM1REG1_ADDR))
#define TMS570_RTP_RAM1REG2        (*((volatile unsigned int*)TMS570_RTP_RAM1REG2_ADDR))
#define TMS570_RTP_RAM2REG1        (*((volatile unsigned int*)TMS570_RTP_RAM2REG1_ADDR))
#define TMS570_RTP_RAM2REG2        (*((volatile unsigned int*)TMS570_RTP_RAM2REG2_ADDR))
#define TMS570_RTP_RAM3REG1        (*((volatile unsigned int*)TMS570_RTP_RAM3REG1_ADDR))
#define TMS570_RTP_RAM3REG2        (*((volatile unsigned int*)TMS570_RTP_RAM3REG2_ADDR))
#define TMS570_RTP_PERREG1         (*((volatile unsigned int*)TMS570_RTP_PERREG1_ADDR))
#define TMS570_RTP_PERREG2         (*((volatile unsigned int*)TMS570_RTP_PERREG2_ADDR))
#define TMS570_RTP_DDMW            (*((volatile unsigned int*)TMS570_RTP_DDMW_ADDR))
#define TMS570_RTP_PHANTOM         (*((volatile unsigned int*)TMS570_RTP_PHANTOM_ADDR))
#define TMS570_RTP_PC0             (*((volatile unsigned int*)TMS570_RTP_PC0_ADDR))


//
// DMM
//

#define TMS570_DMM_BASE_ADDR       (0xfffff700UL)

#define TMS570_DMM_GLBCTRL_ADDR    ((TMS570_DMM_BASE_ADDR) + 0x00)
#define TMS570_DMM_DEST0REG1_ADDR  ((TMS570_DMM_BASE_ADDR) + 0x2c)
#define TMS570_DMM_DEST0BL1_ADDR   ((TMS570_DMM_BASE_ADDR) + 0x30)
#define TMS570_DMM_DEST1REG1_ADDR  ((TMS570_DMM_BASE_ADDR) + 0x3c)
#define TMS570_DMM_DEST1BL1_ADDR   ((TMS570_DMM_BASE_ADDR) + 0x40)
#define TMS570_DMM_PC0_ADDR        ((TMS570_DMM_BASE_ADDR) + 0x6c)

#define TMS570_DMM_GLBCTRL         (*((volatile unsigned int*)TMS570_DMM_GLBCTRL_ADDR))
#define TMS570_DMM_DEST0REG1       (*((volatile unsigned int*)TMS570_DMM_DEST0REG1_ADDR))
#define TMS570_DMM_DEST0BL1        (*((volatile unsigned int*)TMS570_DMM_DEST0BL1_ADDR))
#define TMS570_DMM_DEST1REG1       (*((volatile unsigned int*)TMS570_DMM_DEST1REG1_ADDR))
#define TMS570_DMM_DEST1BL1        (*((volatile unsigned int*)TMS570_DMM_DEST1BL1_ADDR))
#define TMS570_DMM_PC0             (*((volatile unsigned int*)TMS570_DMM_PC0_ADDR))


//
// RTI
//

#define TMS570_RTI_BASE_ADDR       (0xfffffc00UL)

#define TMS570_RTI_GCTRL_ADDR      ((TMS570_RTI_BASE_ADDR) + 0x00)
#define TMS570_RTI_FRC0_ADDR       ((TMS570_RTI_BASE_ADDR) + 0x10)
#define TMS570_RTI_FRC1_ADDR       ((TMS570_RTI_BASE_ADDR) + 0x30)
#define TMS570_RTI_UC1_ADDR        ((TMS570_RTI_BASE_ADDR) + 0x34)
#define TMS570_RTI_CPUC1_ADDR      ((TMS570_RTI_BASE_ADDR) + 0x38)

#define TMS570_RTI_GCTRL           (*((volatile unsigned int*)TMS570_RTI_GCTRL_ADDR))
#define TMS570_RTI_FRC0            (*((volatile unsigned int*)TMS570_RTI_FRC0_ADDR))
#define TMS570_RTI_FRC1            (*((volatile unsigned int*)TMS570_RTI_FRC1_ADDR))
#define TMS570_RTI_UC1             (*((volatile unsigned int*)TMS570_RTI_UC1_ADDR))
#define TMS570_RTI_CPUC1           (*((volatile unsigned int*)TMS570_RTI_CPUC1_ADDR))


//
// GIO
//

#define TMS570_GIO_BASE_ADDR       (0xfff7bc00UL)

#define TMS570_GIO_GCR0_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x00)
#define TMS570_GIO_DIR0_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x34)
#define TMS570_GIO_DIN0_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x38)
#define TMS570_GIO_DOUT0_ADDR      ((TMS570_GIO_BASE_ADDR) + 0x3c)
#define TMS570_GIO_SET0_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x40)
#define TMS570_GIO_CLR0_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x44)
#define TMS570_GIO_DIR1_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x54)
#define TMS570_GIO_DIN1_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x58)
#define TMS570_GIO_DOUT1_ADDR      ((TMS570_GIO_BASE_ADDR) + 0x5c)
#define TMS570_GIO_SET1_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x60)
#define TMS570_GIO_CLR1_ADDR       ((TMS570_GIO_BASE_ADDR) + 0x64)

#define TMS570_GIO_GCR0            (*((volatile unsigned int*)TMS570_GIO_GCR0_ADDR))
#define TMS570_GIO_DIR0            (*((volatile unsigned int*)TMS570_GIO_DIR0_ADDR))
#define TMS570_GIO_DIN0            (*((volatile unsigned int*)TMS570_GIO_DIN0_ADDR))
#define TMS570_GIO_DOUT0           (*((volatile unsigned int*)TMS570_GIO_DOUT0_ADDR))
#define TMS570_GIO_SET0            (*((volatile unsigned int*)TMS570_GIO_SET0_ADDR))
#define TMS570_GIO_CLR0            (*((volatile unsigned int*)TMS570_GIO_CLR0_ADDR))
#define TMS570_GIO_DIR1            (*((volatile unsigned int*)TMS570_GIO_DIR1_ADDR))
#define TMS570_GIO_DIN1            (*((volatile unsigned int*)TMS570_GIO_DIN1_ADDR))
#define TMS570_GIO_DOUT1           (*((volatile unsigned int*)TMS570_GIO_DOUT1_ADDR))
#define TMS570_GIO_SET1            (*((volatile unsigned int*)TMS570_GIO_SET1_ADDR))
#define TMS570_GIO_CLR1            (*((volatile unsigned int*)TMS570_GIO_CLR1_ADDR))


//
// System Control
//

#define TMS570_SYS_BASE_ADDR       (0xffffff00UL)

// Sys Pin Contol Register 2 (controls direction of ECPCLKGIO pin)
#define TMS570_SYS_PC2_ADDR        ((TMS570_SYS_BASE_ADDR) + 0x04)
#define TMS570_SYS_CSDIS_ADDR      ((TMS570_SYS_BASE_ADDR) + 0x30)
#define TMS570_SYS_GHVSRC_ADDR     ((TMS570_SYS_BASE_ADDR) + 0x48)
#define TMS570_SYS_RCLKSRC_ADDR    ((TMS570_SYS_BASE_ADDR) + 0x50)
#define TMS570_SYS_CSVSTAT_ADDR    ((TMS570_SYS_BASE_ADDR) + 0x54)
#define TMS570_SYS_MINITGCR_ADDR   ((TMS570_SYS_BASE_ADDR) + 0x5c)
#define TMS570_SYS_MSIENA_ADDR     ((TMS570_SYS_BASE_ADDR) + 0x60)
#define TMS570_SYS_MSTCGSTAT_ADDR  ((TMS570_SYS_BASE_ADDR) + 0x68)
#define TMS570_SYS_PLLCTL1_ADDR    ((TMS570_SYS_BASE_ADDR) + 0x70)
#define TMS570_SYS_PLLCTL2_ADDR    ((TMS570_SYS_BASE_ADDR) + 0x74)
#define TMS570_SYS_RAMGCR_ADDR     ((TMS570_SYS_BASE_ADDR) + 0xc0)
#define TMS570_SYS_CLKCNTL_ADDR    ((TMS570_SYS_BASE_ADDR) + 0xd0)
#define TMS570_SYS_ECPCNTRL_ADDR   ((TMS570_SYS_BASE_ADDR) + 0xd4)
#define TMS570_SYS_DEVCR1_ADDR     ((TMS570_SYS_BASE_ADDR) + 0xdc)
#define TMS570_SYS_SYSECR_ADDR     ((TMS570_SYS_BASE_ADDR) + 0xe0)
#define TMS570_SYS_SYSESR_ADDR     ((TMS570_SYS_BASE_ADDR) + 0xe4)
#define TMS570_SYS_DEV_ADDR        ((TMS570_SYS_BASE_ADDR) + 0xf0)

#define TMS570_SYS_PC2             (*((volatile unsigned int*)TMS570_SYS_PC2_ADDR))
#define TMS570_SYS_CSDIS           (*((volatile unsigned int*)TMS570_SYS_CSDIS_ADDR))
#define TMS570_SYS_GHVSRC          (*((volatile unsigned int*)TMS570_SYS_GHVSRC_ADDR))
#define TMS570_SYS_RCLKSRC         (*((volatile unsigned int*)TMS570_SYS_RCLKSRC_ADDR))
#define TMS570_SYS_CSVSTAT         (*((volatile unsigned int*)TMS570_SYS_CSVSTAT_ADDR))
#define TMS570_SYS_MINITGCR        (*((volatile unsigned int*)TMS570_SYS_MINITGCR_ADDR))
#define TMS570_SYS_MSIENA          (*((volatile unsigned int*)TMS570_SYS_MSIENA_ADDR))
#define TMS570_SYS_MSTCGSTAT       (*((volatile unsigned int*)TMS570_SYS_MSTCGSTAT_ADDR))
#define TMS570_SYS_PLLCTL1         (*((volatile unsigned int*)TMS570_SYS_PLLCTL1_ADDR))
#define TMS570_SYS_PLLCTL2         (*((volatile unsigned int*)TMS570_SYS_PLLCTL2_ADDR))
#define TMS570_SYS_RAMGCR          (*((volatile unsigned int*)TMS570_SYS_RAMGCR_ADDR))
#define TMS570_SYS_CLKCNTL         (*((volatile unsigned int*)TMS570_SYS_CLKCNTL_ADDR))
#define TMS570_SYS_ECPCNTRL        (*((volatile unsigned int*)TMS570_SYS_ECPCNTRL_ADDR))
#define TMS570_SYS_DEVCR1          (*((volatile unsigned int*)TMS570_SYS_DEVCR1_ADDR))
#define TMS570_SYS_SYSECR          (*((volatile unsigned int*)TMS570_SYS_SYSECR_ADDR))
#define TMS570_SYS_SYSESR          (*((volatile unsigned int*)TMS570_SYS_SYSESR_ADDR))
#define TMS570_SYS_DEV             (*((volatile unsigned int*)TMS570_SYS_DEV_ADDR))


//
// Peripheral Central Resource
//

#define TMS570_PCR_BASE_ADDR       (0xffffe000UL)

#define TMS570_PCR_PSPWRDWNCLR0_ADDR ((TMS570_SYS_BASE_ADDR) + 0xa0)
#define TMS570_PCR_PSPWRDWNCLR1_ADDR ((TMS570_SYS_BASE_ADDR) + 0xa4)
#define TMS570_PCR_PSPWRDWNCLR2_ADDR ((TMS570_SYS_BASE_ADDR) + 0xa8)
#define TMS570_PCR_PSPWRDWNCLR3_ADDR ((TMS570_SYS_BASE_ADDR) + 0xaC)

#define TMS570_PCR_PSPWRDWNCLR0    (*((volatile unsigned int*)TMS570_PCR_PSPWRDWNCLR0_ADDR))
#define TMS570_PCR_PSPWRDWNCLR1    (*((volatile unsigned int*)TMS570_PCR_PSPWRDWNCLR1_ADDR))
#define TMS570_PCR_PSPWRDWNCLR2    (*((volatile unsigned int*)TMS570_PCR_PSPWRDWNCLR2_ADDR))
#define TMS570_PCR_PSPWRDWNCLR3    (*((volatile unsigned int*)TMS570_PCR_PSPWRDWNCLR3_ADDR))


//
// Vectored Interrupt Manager
//

#define TMS570_VIM_BASE_ADDR       (0xfffffe00UL)

#define TMS570_VIM_FIRQPR0_ADDR    ((TMS570_VIM_BASE_ADDR) + 0x10)
#define TMS570_VIM_FIRQPR1_ADDR    ((TMS570_VIM_BASE_ADDR) + 0x14)
#define TMS570_VIM_REQMSKCLR0_ADDR ((TMS570_VIM_BASE_ADDR) + 0x40)
#define TMS570_VIM_REQMSKCLR1_ADDR ((TMS570_VIM_BASE_ADDR) + 0x44)

#define TMS570_VIM_FIRQPR0         (*((volatile unsigned int*)TMS570_VIM_FIRQPR0_ADDR))
#define TMS570_VIM_FIRQPR1         (*((volatile unsigned int*)TMS570_VIM_FIRQPR1_ADDR))
#define TMS570_VIM_REQMSKCLR0      (*((volatile unsigned int*)TMS570_VIM_REQMSKCLR0_ADDR))
#define TMS570_VIM_REQMSKCLR1      (*((volatile unsigned int*)TMS570_VIM_REQMSKCLR1_ADDR))


//
// Flash 
//

#define TMS570_FL_BASE_ADDR        (0xfff87000UL)

#define TMS570_FL_RDCNTL_ADDR      ((TMS570_FL_BASE_ADDR) + 0x00)
#define TMS570_FL_EDACCTRL1_ADDR   ((TMS570_FL_BASE_ADDR) + 0x08)

#define TMS570_FL_RDCNTL           (*((volatile unsigned int*)TMS570_FL_RDCNTL_ADDR))
#define TMS570_FL_EDACCTRL1        (*((volatile unsigned int*)TMS570_FL_EDACCTRL1_ADDR))




//
// I/O Multiplexing and Control Module (IOMM)
//

#define TMS570_IOMM_BASE_ADDR      (0xffff1c00UL)

#define TMS570_IOMM_KICK0_ADDR     ((TMS570_IOMM_BASE_ADDR) + 0x38)
#define TMS570_IOMM_KICK1_ADDR     ((TMS570_IOMM_BASE_ADDR) + 0x3c)
#define TMS570_IOMM_PINMMR_ADDR(x) ((TMS570_IOMM_BASE_ADDR) + 0x110 + ((x) << 2))

#define TMS570_IOMM_KICK0          (*((volatile unsigned int*)TMS570_IOMM_KICK0_ADDR))
#define TMS570_IOMM_KICK1          (*((volatile unsigned int*)TMS570_IOMM_KICK1_ADDR))
#define TMS570_IOMM_PINMMR(x)      (*((volatile unsigned int*)TMS570_IOMM_PINMMR_ADDR(x)))

#define TMS570_KICK0_MAGIC         (0x83e70b13UL)
#define TMS570_KICK1_MAGIC         (0x95a4f1e0UL)



#define TMS570_DEVICE_IS_GLADIATOR ((TMS570_SYS_DEV & 0xffffff00UL) == 0x802aad00UL)


#endif //__TMS570_H__
